summaryrefslogtreecommitdiffstats
path: root/academic
diff options
context:
space:
mode:
author PaulKinsler2019-12-15 09:41:28 +0100
committer Willy Sudiarto Raharjo2019-12-15 09:41:28 +0100
commitf8c9a6fdf1af555278eb0d16ce654b6cb107ba84 (patch)
tree57bb845f8b6153cd36202048ccf8a780a5ed1271 /academic
parent1e6183df528835fb6a87704474be656d393ac061 (diff)
downloadslackbuilds-f8c9a6fdf1af555278eb0d16ce654b6cb107ba84.tar.gz
academic/meep: Added (electromagnetics simulation using FDTD).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'academic')
-rw-r--r--academic/meep/README14
-rw-r--r--academic/meep/meep.SlackBuild123
-rw-r--r--academic/meep/meep.info10
-rw-r--r--academic/meep/slack-desc17
4 files changed, 164 insertions, 0 deletions
diff --git a/academic/meep/README b/academic/meep/README
new file mode 100644
index 0000000000..9baddd56dd
--- /dev/null
+++ b/academic/meep/README
@@ -0,0 +1,14 @@
+meep (electromagnetic FDTD solver)
+
+Meep is a free and open-source software package for
+electromagnetics simulation via the finite-difference
+time-domain (FDTD) method spanning a broad range of
+applications.
+
+You may wish to preinstall: harminv, mpb
+
+You may wish to also install: h5utils
+
+If the build script can find the ATLAS libraries, it will
+adapt the configure options to use them rather than the
+default lapack.
diff --git a/academic/meep/meep.SlackBuild b/academic/meep/meep.SlackBuild
new file mode 100644
index 0000000000..3542bc7e36
--- /dev/null
+++ b/academic/meep/meep.SlackBuild
@@ -0,0 +1,123 @@
+#!/bin/sh
+
+# Slackware build script for meep
+
+# Copyright 2019 Paul Kinsler, U.K.
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=meep
+VERSION=${VERSION:-1.12.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+# change annoying underscores into hyphens
+SVERSION=$(echo $VERSION | tr '_' '-')
+# make a custom list of doc files in advance
+DOCFILES="AUTHORS COPYRIGHT LICENSE TODO NEWS.md"
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$SVERSION
+tar xvf $CWD/$PRGNAM-$SVERSION.tar.gz
+cd $PRGNAM-$SVERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+LOCALCONFIGS=" --without-python --with-mpi "
+
+# check for the Atlas replacement for blas; if the libraries are found,
+# add the configure option accordingly
+
+if [ -f /usr/lib${LIBDIRSUFFIX}/libatlas.a ] ; then
+ if [ -f /usr/lib${LIBIRSUFFIX}/libatlas.so ] ; then
+ echo "NOTICE: libatlas was found, configure --with-blas=atlas"
+ LOCALCONFIGS=${LOCALCONFIGS}" --with-blas=atlas"
+ fi
+fi
+
+CFLAGS="$SLKCFLAGS" \
+CPPFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --mandir=/usr/man \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux \
+ --disable-static \
+ $LOCALCONFIGS
+
+make
+make install DESTDIR=$PKG
+
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+#find $PKG/usr/man -type f -exec gzip -9 {} \;
+#for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+install -m 0644 $DOCFILES $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+if [ -f $CWD/doinst.sh ] ; then
+ cat $CWD/doinst.sh > $PKG/install/doinst.sh
+fi
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/academic/meep/meep.info b/academic/meep/meep.info
new file mode 100644
index 0000000000..4c77d9c392
--- /dev/null
+++ b/academic/meep/meep.info
@@ -0,0 +1,10 @@
+PRGNAM="meep"
+VERSION="1.12.0"
+HOMEPAGE="https://github.com/NanoComp/meep"
+DOWNLOAD="https://github.com/NanoComp/meep/releases/download/v1.12.0/meep-1.12.0.tar.gz"
+MD5SUM="ce2064167a540036f315b5b7b4b8253e"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="lapack openmpi hdf5 libctl"
+MAINTAINER="PaulKinsler"
+EMAIL="dr.paul@kinsler.org"
diff --git a/academic/meep/slack-desc b/academic/meep/slack-desc
new file mode 100644
index 0000000000..3a624bb611
--- /dev/null
+++ b/academic/meep/slack-desc
@@ -0,0 +1,17 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+meep: meep (electromagnetics simulation using FDTD)
+meep:
+meep: Meep is a free and open-source software package for
+meep: electromagnetics simulation via the finite-difference
+meep: time-domain (FDTD) method spanning a broad range of
+meep: applications.
+meep:
+meep: Homepage: https://github.com/NanoComp/meep
+meep: